/**
 * This list states the country names (official short names in English) as given in ISO 3166-1 and the corresponding ISO
 * 3166-1-alpha-2 code elements.
 */
Aria.classDefinition({
	$classpath : "samples.widgets.widgetlibs.html.autocomplete.common.Resources",
	$extends : "aria.resources.handlers.LCResourcesHandler",
	$constructor : function () {
		this.$LCResourcesHandler.constructor.apply(this, arguments);

		this.setSuggestions([{
					label : "AFGHANISTAN",
					code : "AF"
				}, {
					label : "ÅLAND ISLANDS",
					code : "AX"
				}, {
					label : "ALBANIA",
					code : "AL"
				}, {
					label : "ALGERIA",
					code : "DZ"
				}, {
					label : "AMERICAN SAMOA",
					code : "AS"
				}, {
					label : "ANDORRA",
					code : "AD"
				}, {
					label : "ANGOLA",
					code : "AO"
				}, {
					label : "ANGUILLA",
					code : "AI"
				}, {
					label : "ANTARCTICA",
					code : "AQ"
				}, {
					label : "ANTIGUA AND BARBUDA",
					code : "AG"
				}, {
					label : "ARGENTINA",
					code : "AR"
				}, {
					label : "ARMENIA",
					code : "AM"
				}, {
					label : "ARUBA",
					code : "AW"
				}, {
					label : "AUSTRALIA",
					code : "AU"
				}, {
					label : "AUSTRIA",
					code : "AT"
				}, {
					label : "AZERBAIJAN",
					code : "AZ"
				}, {
					label : "BAHAMAS",
					code : "BS"
				}, {
					label : "BAHRAIN",
					code : "BH"
				}, {
					label : "BANGLADESH",
					code : "BD"
				}, {
					label : "BARBADOS",
					code : "BB"
				}, {
					label : "BELARUS",
					code : "BY"
				}, {
					label : "BELGIUM",
					code : "BE"
				}, {
					label : "BELIZE",
					code : "BZ"
				}, {
					label : "BENIN",
					code : "BJ"
				}, {
					label : "BERMUDA",
					code : "BM"
				}, {
					label : "BHUTAN",
					code : "BT"
				}, {
					label : "BOLIVIA, PLURINATIONAL STATE OF",
					code : "BO"
				}, {
					label : "BONAIRE, SINT EUSTATIUS AND SABA",
					code : "BQ"
				}, {
					label : "BOSNIA AND HERZEGOVINA",
					code : "BA"
				}, {
					label : "BOTSWANA",
					code : "BW"
				}, {
					label : "BOUVET ISLAND",
					code : "BV"
				}, {
					label : "BRAZIL",
					code : "BR"
				}, {
					label : "BRITISH INDIAN OCEAN TERRITORY",
					code : "IO"
				}, {
					label : "BRUNEI DARUSSALAM",
					code : "BN"
				}, {
					label : "BULGARIA",
					code : "BG"
				}, {
					label : "BURKINA FASO",
					code : "BF"
				}, {
					label : "BURUNDI",
					code : "BI"
				}, {
					label : "CAMBODIA",
					code : "KH"
				}, {
					label : "CAMEROON",
					code : "CM"
				}, {
					label : "CANADA",
					code : "CA"
				}, {
					label : "CAPE VERDE",
					code : "CV"
				}, {
					label : "CAYMAN ISLANDS",
					code : "KY"
				}, {
					label : "CENTRAL AFRICAN REPUBLIC",
					code : "CF"
				}, {
					label : "CHAD",
					code : "TD"
				}, {
					label : "CHILE",
					code : "CL"
				}, {
					label : "CHINA",
					code : "CN"
				}, {
					label : "CHRISTMAS ISLAND",
					code : "CX"
				}, {
					label : "COCOS (KEELING) ISLANDS",
					code : "CC"
				}, {
					label : "COLOMBIA",
					code : "CO"
				}, {
					label : "COMOROS",
					code : "KM"
				}, {
					label : "CONGO",
					code : "CG"
				}, {
					label : "CONGO, THE DEMOCRATIC REPUBLIC OF THE",
					code : "CD"
				}, {
					label : "COOK ISLANDS",
					code : "CK"
				}, {
					label : "COSTA RICA",
					code : "CR"
				}, {
					label : "CÔTE D'IVOIRE",
					code : "CI"
				}, {
					label : "CROATIA",
					code : "HR"
				}, {
					label : "CUBA",
					code : "CU"
				}, {
					label : "CURAÇAO",
					code : "CW"
				}, {
					label : "CYPRUS",
					code : "CY"
				}, {
					label : "CZECH REPUBLIC",
					code : "CZ"
				}, {
					label : "DENMARK",
					code : "DK"
				}, {
					label : "DJIBOUTI",
					code : "DJ"
				}, {
					label : "DOMINICA",
					code : "DM"
				}, {
					label : "DOMINICAN REPUBLIC",
					code : "DO"
				}, {
					label : "ECUADOR",
					code : "EC"
				}, {
					label : "EGYPT",
					code : "EG"
				}, {
					label : "EL SALVADOR",
					code : "SV"
				}, {
					label : "EQUATORIAL GUINEA",
					code : "GQ"
				}, {
					label : "ERITREA",
					code : "ER"
				}, {
					label : "ESTONIA",
					code : "EE"
				}, {
					label : "ETHIOPIA",
					code : "ET"
				}, {
					label : "FALKLAND ISLANDS (MALVINAS)",
					code : "FK"
				}, {
					label : "FAROE ISLANDS",
					code : "FO"
				}, {
					label : "FIJI",
					code : "FJ"
				}, {
					label : "FINLAND",
					code : "FI"
				}, {
					label : "FRANCE",
					code : "FR"
				}, {
					label : "FRENCH GUIANA",
					code : "GF"
				}, {
					label : "FRENCH POLYNESIA",
					code : "PF"
				}, {
					label : "FRENCH SOUTHERN TERRITORIES",
					code : "TF"
				}, {
					label : "GABON",
					code : "GA"
				}, {
					label : "GAMBIA",
					code : "GM"
				}, {
					label : "GEORGIA",
					code : "GE"
				}, {
					label : "GERMANY",
					code : "DE"
				}, {
					label : "GHANA",
					code : "GH"
				}, {
					label : "GIBRALTAR",
					code : "GI"
				}, {
					label : "GREECE",
					code : "GR"
				}, {
					label : "GREENLAND",
					code : "GL"
				}, {
					label : "GRENADA",
					code : "GD"
				}, {
					label : "GUADELOUPE",
					code : "GP"
				}, {
					label : "GUAM",
					code : "GU"
				}, {
					label : "GUATEMALA",
					code : "GT"
				}, {
					label : "GUERNSEY",
					code : "GG"
				}, {
					label : "GUINEA",
					code : "GN"
				}, {
					label : "GUINEA-BISSAU",
					code : "GW"
				}, {
					label : "GUYANA",
					code : "GY"
				}, {
					label : "HAITI",
					code : "HT"
				}, {
					label : "HEARD ISLAND AND MCDONALD ISLANDS",
					code : "HM"
				}, {
					label : "HOLY SEE (VATICAN CITY STATE)",
					code : "VA"
				}, {
					label : "HONDURAS",
					code : "HN"
				}, {
					label : "HONG KONG",
					code : "HK"
				}, {
					label : "HUNGARY",
					code : "HU"
				}, {
					label : "ICELAND",
					code : "IS"
				}, {
					label : "INDIA",
					code : "IN"
				}, {
					label : "INDONESIA",
					code : "ID"
				}, {
					label : "IRAN, ISLAMIC REPUBLIC OF",
					code : "IR"
				}, {
					label : "IRAQ",
					code : "IQ"
				}, {
					label : "IRELAND",
					code : "IE"
				}, {
					label : "ISLE OF MAN",
					code : "IM"
				}, {
					label : "ISRAEL",
					code : "IL"
				}, {
					label : "ITALY",
					code : "IT"
				}, {
					label : "JAMAICA",
					code : "JM"
				}, {
					label : "JAPAN",
					code : "JP"
				}, {
					label : "JERSEY",
					code : "JE"
				}, {
					label : "JORDAN",
					code : "JO"
				}, {
					label : "KAZAKHSTAN",
					code : "KZ"
				}, {
					label : "KENYA",
					code : "KE"
				}, {
					label : "KIRIBATI",
					code : "KI"
				}, {
					label : "KOREA, DEMOCRATIC PEOPLE'S REPUBLIC OF",
					code : "KP"
				}, {
					label : "KOREA, REPUBLIC OF",
					code : "KR"
				}, {
					label : "KUWAIT",
					code : "KW"
				}, {
					label : "KYRGYZSTAN",
					code : "KG"
				}, {
					label : "LAO PEOPLE'S DEMOCRATIC REPUBLIC",
					code : "LA"
				}, {
					label : "LATVIA",
					code : "LV"
				}, {
					label : "LEBANON",
					code : "LB"
				}, {
					label : "LESOTHO",
					code : "LS"
				}, {
					label : "LIBERIA",
					code : "LR"
				}, {
					label : "LIBYA",
					code : "LY"
				}, {
					label : "LIECHTENSTEIN",
					code : "LI"
				}, {
					label : "LITHUANIA",
					code : "LT"
				}, {
					label : "LUXEMBOURG",
					code : "LU"
				}, {
					label : "MACAO",
					code : "MO"
				}, {
					label : "MACEDONIA, THE FORMER YUGOSLAV REPUBLIC OF",
					code : "MK"
				}, {
					label : "MADAGASCAR",
					code : "MG"
				}, {
					label : "MALAWI",
					code : "MW"
				}, {
					label : "MALAYSIA",
					code : "MY"
				}, {
					label : "MALDIVES",
					code : "MV"
				}, {
					label : "MALI",
					code : "ML"
				}, {
					label : "MALTA",
					code : "MT"
				}, {
					label : "MARSHALL ISLANDS",
					code : "MH"
				}, {
					label : "MARTINIQUE",
					code : "MQ"
				}, {
					label : "MAURITANIA",
					code : "MR"
				}, {
					label : "MAURITIUS",
					code : "MU"
				}, {
					label : "MAYOTTE",
					code : "YT"
				}, {
					label : "MEXICO",
					code : "MX"
				}, {
					label : "MICRONESIA, FEDERATED STATES OF",
					code : "FM"
				}, {
					label : "MOLDOVA, REPUBLIC OF",
					code : "MD"
				}, {
					label : "MONACO",
					code : "MC"
				}, {
					label : "MONGOLIA",
					code : "MN"
				}, {
					label : "MONTENEGRO",
					code : "ME"
				}, {
					label : "MONTSERRAT",
					code : "MS"
				}, {
					label : "MOROCCO",
					code : "MA"
				}, {
					label : "MOZAMBIQUE",
					code : "MZ"
				}, {
					label : "MYANMAR",
					code : "MM"
				}, {
					label : "NAMIBIA",
					code : "NA"
				}, {
					label : "NAURU",
					code : "NR"
				}, {
					label : "NEPAL",
					code : "NP"
				}, {
					label : "NETHERLANDS",
					code : "NL"
				}, {
					label : "NEW CALEDONIA",
					code : "NC"
				}, {
					label : "NEW ZEALAND",
					code : "NZ"
				}, {
					label : "NICARAGUA",
					code : "NI"
				}, {
					label : "NIGER",
					code : "NE"
				}, {
					label : "NIGERIA",
					code : "NG"
				}, {
					label : "NIUE",
					code : "NU"
				}, {
					label : "NORFOLK ISLAND",
					code : "NF"
				}, {
					label : "NORTHERN MARIANA ISLANDS",
					code : "MP"
				}, {
					label : "NORWAY",
					code : "NO"
				}, {
					label : "OMAN",
					code : "OM"
				}, {
					label : "PAKISTAN",
					code : "PK"
				}, {
					label : "PALAU",
					code : "PW"
				}, {
					label : "PALESTINIAN TERRITORY, OCCUPIED",
					code : "PS"
				}, {
					label : "PANAMA",
					code : "PA"
				}, {
					label : "PAPUA NEW GUINEA",
					code : "PG"
				}, {
					label : "PARAGUAY",
					code : "PY"
				}, {
					label : "PERU",
					code : "PE"
				}, {
					label : "PHILIPPINES",
					code : "PH"
				}, {
					label : "PITCAIRN",
					code : "PN"
				}, {
					label : "POLAND",
					code : "PL"
				}, {
					label : "PORTUGAL",
					code : "PT"
				}, {
					label : "PUERTO RICO",
					code : "PR"
				}, {
					label : "QATAR",
					code : "QA"
				}, {
					label : "RÉUNION",
					code : "RE"
				}, {
					label : "ROMANIA",
					code : "RO"
				}, {
					label : "RUSSIAN FEDERATION",
					code : "RU"
				}, {
					label : "RWANDA",
					code : "RW"
				}, {
					label : "SAINT BARTHÉLEMY",
					code : "BL"
				}, {
					label : "SAINT HELENA, ASCENSION AND TRISTAN DA CUNHA",
					code : "SH"
				}, {
					label : "SAINT KITTS AND NEVIS",
					code : "KN"
				}, {
					label : "SAINT LUCIA",
					code : "LC"
				}, {
					label : "SAINT MARTIN (FRENCH PART)",
					code : "MF"
				}, {
					label : "SAINT PIERRE AND MIQUELON",
					code : "PM"
				}, {
					label : "SAINT VINCENT AND THE GRENADINES",
					code : "VC"
				}, {
					label : "SAMOA",
					code : "WS"
				}, {
					label : "SAN MARINO",
					code : "SM"
				}, {
					label : "SAO TOME AND PRINCIPE",
					code : "ST"
				}, {
					label : "SAUDI ARABIA",
					code : "SA"
				}, {
					label : "SENEGAL",
					code : "SN"
				}, {
					label : "SERBIA",
					code : "RS"
				}, {
					label : "SEYCHELLES",
					code : "SC"
				}, {
					label : "SIERRA LEONE",
					code : "SL"
				}, {
					label : "SINGAPORE",
					code : "SG"
				}, {
					label : "SINT MAARTEN (DUTCH PART)",
					code : "SX"
				}, {
					label : "SLOVAKIA",
					code : "SK"
				}, {
					label : "SLOVENIA",
					code : "SI"
				}, {
					label : "SOLOMON ISLANDS",
					code : "SB"
				}, {
					label : "SOMALIA",
					code : "SO"
				}, {
					label : "SOUTH AFRICA",
					code : "ZA"
				}, {
					label : "SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS",
					code : "GS"
				}, {
					label : "SOUTH SUDAN",
					code : "SS"
				}, {
					label : "SPAIN",
					code : "ES"
				}, {
					label : "SRI LANKA",
					code : "LK"
				}, {
					label : "SUDAN",
					code : "SD"
				}, {
					label : "SURINAME",
					code : "SR"
				}, {
					label : "SVALBARD AND JAN MAYEN",
					code : "SJ"
				}, {
					label : "SWAZILAND",
					code : "SZ"
				}, {
					label : "SWEDEN",
					code : "SE"
				}, {
					label : "SWITZERLAND",
					code : "CH"
				}, {
					label : "SYRIAN ARAB REPUBLIC",
					code : "SY"
				}, {
					label : "TAIWAN, PROVINCE OF CHINA",
					code : "TW"
				}, {
					label : "TAJIKISTAN",
					code : "TJ"
				}, {
					label : "TANZANIA, UNITED REPUBLIC OF",
					code : "TZ"
				}, {
					label : "THAILAND",
					code : "TH"
				}, {
					label : "TIMOR-LESTE",
					code : "TL"
				}, {
					label : "TOGO",
					code : "TG"
				}, {
					label : "TOKELAU",
					code : "TK"
				}, {
					label : "TONGA",
					code : "TO"
				}, {
					label : "TRINIDAD AND TOBAGO",
					code : "TT"
				}, {
					label : "TUNISIA",
					code : "TN"
				}, {
					label : "TURKEY",
					code : "TR"
				}, {
					label : "TURKMENISTAN",
					code : "TM"
				}, {
					label : "TURKS AND CAICOS ISLANDS",
					code : "TC"
				}, {
					label : "TUVALU",
					code : "TV"
				}, {
					label : "UGANDA",
					code : "UG"
				}, {
					label : "UKRAINE",
					code : "UA"
				}, {
					label : "UNITED ARAB EMIRATES",
					code : "AE"
				}, {
					label : "UNITED KINGDOM",
					code : "GB"
				}, {
					label : "UNITED STATES",
					code : "US"
				}, {
					label : "UNITED STATES MINOR OUTLYING ISLANDS",
					code : "UM"
				}, {
					label : "URUGUAY",
					code : "UY"
				}, {
					label : "UZBEKISTAN",
					code : "UZ"
				}, {
					label : "VANUATU",
					code : "VU"
				}, {
					label : "VENEZUELA, BOLIVARIAN REPUBLIC OF",
					code : "VE"
				}, {
					label : "VIET NAM",
					code : "VN"
				}, {
					label : "VIRGIN ISLANDS, BRITISH",
					code : "VG"
				}, {
					label : "VIRGIN ISLANDS, U.S.",
					code : "VI"
				}, {
					label : "WALLIS AND FUTUNA",
					code : "WF"
				}, {
					label : "WESTERN SAHARA",
					code : "EH"
				}, {
					label : "YEMEN",
					code : "YE"
				}, {
					label : "ZAMBIA",
					code : "ZM"
				}, {
					label : "ZIMBABWE",
					code : "ZW"
				}]);
	}
});